Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.fdk
Class CategoryManager

All Superinterfaces:
  java.rmi.Remote

All Known Implementing Classes:
  CategoryManagerImpl, CoreCategoryManager

    public interface class CategoryManager

extends java.rmi.Remote

The Category management Facade interface

Method Summary
`Item` | `addMetaDataAttribute(long mdscatId, NamedValue attributedef, AttributeRequest[] attrrequest)` Adds an attribute to a category subclass.
`Item` | `createCategorySubClass(NamedValue[] attributes, AttributeRequest[] attrrequest)` Creates a Category subclass.
`void` | `deleteCategory(long categoryId)` Deprecated. use `FileManager.updateDocuments`
`void` | `freeCategoryClass(long ahcclassId)` Frees the given class object.
`Item[]` | `getRequiredCategories(long folderId, AttributeRequest[] requestedAttributes)` Deprecated. Request REQUIRED_CATEGORIES on CategoryConfiguration
`Item` | `modifyCategorySubClass(long mdscatId, NamedValue[] attributes, AttributeRequest[] attrrequest)` Modifies the given Category subclass.
`Item` | `modifyMetaDataAttribute(long attributeId, NamedValue attributedef, AttributeRequest[] attrrequest)` Given an Attribute description, modify the attribute to the given class and return the modified classobject id.
`void` | `removeCategoryAttribute(long mdscatId, java.lang.String attrName)` Deprecated. use removeMetaDataAttibute
`void` | `removeCategoryConfiguration(long folderId)` remove the existing CategoryConfiguration for a Folder.
`void` | `removeMetaDataAttribute(long attributeId)` Remove an attribute from a MetaDataCategory class.
`void` | `setCategoryConfiguration(long folderId, NamedValue[] config)` Sets or updates the CategoryConfiguration for a Folder.
`Item` | `updateCategory(long catId, NamedValue[] ahcDef, AttributeRequest[] attributes)` Deprecated. use `FileManager.updateDocuments`

Method Detail

### createCategorySubClass

    Item createCategorySubClass(NamedValue[] attributes,
                                AttributeRequest[] attrrequest)
                                throws FdkException

  Description copied from interface: `CategoryManager`
  Creates a Category subclass.

  Given an array of Attributes that describes a class object, create the Category class object and return the classobject id. If Workflow is enabled AND 'CreateUserCategory' is workflow enabled, then an item of type 'REQUEST' is returned. Otherwise, the function returns the created category. UI implementers should check the type of the Item returned and act accordingly (If it's a request, inform user the request needs to be approved before the category can be created.).

  Parameters:
    `attributes` - array of attributes for creating the category class
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.SUPERCLASS, long}
    - {Attributes.CLASS_ABSTRACT, Boolean}
    - {Attributes.CLASS_FINAL, Boolean}
    - {Attributes.CLASS_HIDDEN, Boolean}
    - {Attributes.CATEGORY_COPY_ON_VERSION, Boolean}
    - {Attributes.METADATA_ATTRIBUTES, NamedValueSet[]}
      - {Attributes.NAME, String},
      - {Attributes.ATTRIBUTE_NAME, String}, optional, must start with "CUSTOM_"
      - {Attributes.ATTRIBUTE_REQUIRED, Boolean}
      - {Attributes.ATTRIBUTE_SETTABLE, Boolean}
      - {Attributes.ATTRIBUTE_UPDATEABLE, Boolean}
      - {Attributes.ATTRIBUTE_HIDDEN, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDEABLE, Boolean}
      - {Attributes.ATTRIBUTE_INDEXED, Boolean}
      - {Attributes.ATTRIBUTE_TYPE, Integer}
      - Where value of ATTRIBUTE_TYPE is
        - FdkConstants.ATTRIBUTE_TYPE_STRING
        - FdkConstants.ATTRIBUTE_TYPE_STRING_ARRAY
        - FdkConstants.ATTRIBUTE_TYPE_DATE
        - FdkConstants.ATTRIBUTE_TYPE_INTEGER
        - FdkConstants.ATTRIBUTE_TYPE_LONG
        - FdkConstants.ATTRIBUTE_TYPE_BOOLEAN
        - FdkConstants.ATTRIBUTE_TYPE_FLOAT
        - FdkConstants.ATTRIBUTE_TYPE_USER
        - FdkConstants.ATTRIBUTE_TYPE_GROUP
      - {Attributes.ATTRIBUTE_DEFAULT, type, where type is String, String [], date, int, long, boolean, float or double}
      - {Attributes.ATTRIBUTE_ENUMERATION, [] type, where type is String, int, or long}
    - {Attributes.REQUEST_JUSTIFICATION, String}
    `attrrequest` - requested attributes for each item, or null.
  Returns:
    id of the newly created subclass
  Throws:
    `FdkException` - if the operation fails

### addMetaDataAttribute

    Item addMetaDataAttribute(long mdscatId,
                              NamedValue attributedef,
                              AttributeRequest[] attrrequest)
                              throws FdkException

  Description copied from interface: `CategoryManager`
  Adds an attribute to a category subclass.

  Parameters:
    `mdscatId` - id of category to which to add this attribute
    `attributedef` - array of NamedValue for adding a new attribute {Attributes.ATTRIBUTE_DETAIL, NamedValue[]}
    - {Attributes.NAME, String}
    - {Attributes.ATTRIBUTE_NAME, String}, optional, must start with "CUSTOM_"
    - {Attributes.ATTRIBUTE_REQUIRED, Boolean}
    - {Attributes.ATTRIBUTE_SETTABLE, Boolean}
    - {Attributes.ATTRIBUTE_UPDATEABLE, Boolean}
    - {Attributes.ATTRIBUTE_HIDDEN, Boolean}
    - {Attributes.ATTRIBUTE_PROMPT, Boolean}
    - {Attributes.ATTRIBUTE_OVERRIDEABLE, Boolean}
    - {Attributes.ATTRIBUTE_INDEXED, Boolean}
    - {Attributes.ATTRIBUTE_TYPE, Integer}
    - Where value of ATTRIBUTE_TYPE is
      - FdkConstants.ATTRIBUTE_TYPE_STRING
      - FdkConstants.ATTRIBUTE_TYPE_STRING_ARRAY
      - FdkConstants.ATTRIBUTE_TYPE_DATE
      - FdkConstants.ATTRIBUTE_TYPE_INTEGER
      - FdkConstants.ATTRIBUTE_TYPE_LONG
      - FdkConstants.ATTRIBUTE_TYPE_BOOLEAN
      - FdkConstants.ATTRIBUTE_TYPE_FLOAT
      - FdkConstants.ATTRIBUTE_TYPE_USER
      - FdkConstants.ATTRIBUTE_TYPE_GROUP
    - {Attributes.ATTRIBUTE_DEFAULT, type, where type is String, String [], date, int, long, boolean, float or double}
    - {Attributes.ATTRIBUTE_ENUMERATION, [] type, where type is String, int, or long}
    `attrrequest` - requested attributes for each item, or null.
  Returns:
    id of the newly created attribute.
  Throws:
    `FdkException` - if the operation fails

### modifyMetaDataAttribute

    Item modifyMetaDataAttribute(long attributeId,
                                 NamedValue attributedef,
                                 AttributeRequest[] attrrequest)
                                 throws FdkException

  Description copied from interface: `CategoryManager`
  Given an Attribute description, modify the attribute to the given class and return the modified classobject id.

  Parameters:
    `attributeId` - id of attribute to be modified.
    `attributedef` - array of NamedValue for adding a new attribute Attributes.ATTRIBUTE_DETAIL, NamedValue[]
    - {Attributes.NAME, String}
    - {Attributes.ATTRIBUTE_SETTABLE, Boolean}
    - {Attributes.ATTRIBUTE_UPDATEABLE, Boolean}
    - {Attributes.ATTRIBUTE_REQUIRED, Boolean}
    - {Attributes.ATTRIBUTE_PROMPT, Boolean}
    - {Attributes.ATTRIBUTE_HIDDEN, Boolean}
    - {Attributes.ATTRIBUTE_OVERRIDEABLE, Boolean}
    - {Attributes.ATTRIBUTE_DEFAULT, type}
    - {Attributes.ATTRIBUTE_ENUMERATION, [] type, where type is String, int, or long}
    `attrrequest` - requested attributes for each item, or null.
  Returns:
    newly modified METADATA_ATTRIBUTE
  Throws:
    `FdkException` - if the operation fails

### modifyCategorySubClass

    Item modifyCategorySubClass(long mdscatId,
                                NamedValue[] attributes,
                                AttributeRequest[] attrrequest)
                                throws FdkException

  Description copied from interface: `CategoryManager`
  Modifies the given Category subclass.

  Parameters:
    `attributes` - array of attributes for creating the category class
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.CLASS_HIDDEN, Boolean}
    - {Attributes.CATEGORY_COPY_ON_VERSION, Boolean}
  Throws:
    `FdkException` - if the operation fails

### removeCategoryAttribute

    void removeCategoryAttribute(long mdscatId,
                                 java.lang.String attrName)
                                 throws FdkException

  Deprecated. use removeMetaDataAttibute

  Description copied from interface: `CategoryManager`
  Remove an attribute from a MetaDataCategory class.

  This operation cannot be undone.

  Parameters:
    `mdscatId` - id of category whose attribute will be modified
    `attrName` - name of attribute to remove.
  Throws:
    `FdkException` - if the operation fails

### removeMetaDataAttribute

    void removeMetaDataAttribute(long attributeId)
                                 throws FdkException

  Description copied from interface: `CategoryManager`
  Remove an attribute from a MetaDataCategory class.

  This operation cannot be undone.

  Parameters:
    `attributeId` - id of MetaDataAttribute to remove.
  Throws:
    `FdkException` - if the operation fails

### setCategoryConfiguration

    void setCategoryConfiguration(long folderId,
                                  NamedValue[] config)
                                  throws FdkException

  Description copied from interface: `CategoryManager`
  Sets or updates the CategoryConfiguration for a Folder.

  The entire configuration will replaced as a set and not added to the existing one. AttributeOverrides are replaced as a set. To change one, you must specify all overrides. To remove all overrides, explicitly set ATTRIBUTE_OVERRIDE to null.

  Parameters:
    `folderId` - the folder for which to set the Category configuration
    `config` - the Category configuration options to set; must include one or more of the following Attributes:
    - notation: {Attribute name, Attribute type}
    - {Attributes.ALLOW_ALL_CATEGORIES, Boolean}
    - {Attributes.ALLOWED_CATEGORIES, long[]} each element is an Category Class.
    - {Attributes.CONFIGURATION_FINAL, Boolean}
    - {Attributes.CONFIGURATION_ENABLED, Boolean}
    - {Attributes.ATTRIBUTE_OVERRIDE, NamedValue []} can be specificied multiple times, one for each attribute.
      - {Attributes.ATTRIBUTE_OVERRIDE_CATEGORY_CLASS, id}
      - {Attributes.ATTRIBUTE_OVERRIDE_ATTRIBUTE, id}
      - {Attributes.ATTRIBUTE_OVERRIDE_DEFAULT, Object}
      - {Attributes.ATTRIBUTE_OVERRIDE_DEFAULT_SET, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDE_PROMPT, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDE_REQUIRED, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDE_SETTABLE, Boolean}
  Throws:
    `FdkException` - if the operation fails.

### removeCategoryConfiguration

    void removeCategoryConfiguration(long folderId)
                                     throws FdkException

  Description copied from interface: `CategoryManager`
  remove the existing CategoryConfiguration for a Folder.

  Parameters:
    `folderId` - the folder for which to remove the Category configuration
  Throws:
    `FdkException` - if the operation fails.

### freeCategoryClass

    void freeCategoryClass(long ahcclassId)
                           throws FdkException

  Description copied from interface: `CategoryManager`
  Frees the given class object.

  Only succeeds if no instances or subclasses exists.

  Parameters:
    `ahcclassId` - - the Id representing the Category ClassObject
  Throws:
    `FdkException` - if the operation fails

### getRequiredCategories

    Item[] getRequiredCategories(long folderId,
                                 AttributeRequest[] requestedAttributes)
                                 throws FdkException

  Deprecated. Request REQUIRED_CATEGORIES on CategoryConfiguration

  Description copied from interface: `CategoryManager`
  Gets the required categories for a folder.

  Parameters:
    `folderId` - folder for to fetch the categories
    `requestedAttributes` - list of attributes needed for each item
  Returns:
    required categories for this folder; null if no category is marked as required.

  Throws:
    `FdkException` - if the operation fails

### updateCategory

    Item updateCategory(long catId,
                        NamedValue[] ahcDef,
                        AttributeRequest[] attributes)
                        throws FdkException

  Deprecated. use `FileManager.updateDocuments`

  Description copied from interface: `CategoryManager`
  Updates an existing Category.

  Note, this method will not return the new category if this update causes the associated document to create a new version. Use `FileManager.updateDocuments` instead, which will return the new document Item (and its associated categories, which will reflect the update).

  Parameters:
    `catId` - Category to be updated
    `ahcDef` - the attributes to update.
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {custom_attribute_name, value}
    `attributes` - requested attributes for each item, or null.
  Returns:
    the updated Category.
  Throws:
    `FdkException` - if the operation fails

### deleteCategory

    void deleteCategory(long categoryId)
                        throws FdkException

  Deprecated. use `FileManager.updateDocuments`

  Description copied from interface: `CategoryManager`
  Delete a Category instance.

  Parameters:
    `categoryId` - the category ID to be deleted.
  Throws:
    `FdkException` - if the operation fails.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD